package ejb30.inherit.client.outside;

import java.util.*;
import javax.persistence.*;
import java.lang.reflect.*;


import ejb30.inherit.entity.*;
import com.sun.ejte.ccl.reporter.SimpleReporterAdapter;

public class TestClient {
	
    EntityManagerFactory emf = 
       Persistence.createEntityManagerFactory("manager", new HashMap());
    EntityManager manager = emf.createEntityManager();

    public TestClient() {
    }
      
    public static Account account1, account2, account3, 
           account4, account5, account6;
    public static VIPClientAgent agent1;
    public static PhoneAgent agent2, agent3;

    // Create a savings account      
    public boolean create1() {
        
        boolean pass=false;


        Account account=null; 
        String accountType = "savings";

        // Account items
        String acctNum = "A10001";
        String name = "acct1";
        String description = "acct1des";
        String status = "open";
        String created = "Yes";
        String balance = "1000";
        float  fBalance = 0;

        // BankAccount items
        String bankName = "Bank of America";
   
        // SavingAccount items
        String savingsRate = "0.05";

        float fRate=0;
        try{
	  fRate=Float.valueOf(savingsRate);
        }catch(Exception ex){
	  ex.printStackTrace();
	}
                
	account = new SavingsAccount();

	((SavingsAccount)account).setSavingsRate(fRate);

        ((BankAccount)account).setBankName(bankName);

        // set Account items 
        try{
            fBalance=Float.valueOf(balance);
        }catch(Exception ex){
            ex.printStackTrace();
        }
        account.setAcctNum(acctNum);
        account.setBalance(fBalance);
        account.setDescription(description);
        account.setName(name);
        account.setCreated(created);
        if ("open".equalsIgnoreCase(status)){
            account.setStatus(Account.Status.OPEN);
        }else{
            account.setStatus(Account.Status.CLOSED);
        }

        account1 = account;       

        try {

	    EntityTransaction tx = manager.getTransaction();
            tx.begin();
            manager.persist(account);
            tx.commit();
            pass = true;
            
        } catch(Throwable e){
            e.printStackTrace();
        }
        
        return pass;
    }

    //Find a savings account      
    public boolean find1() {
        
        boolean pass=false;

        Account account=null; 
        String acctNum = "A10001";

        try {
	    System.out.println("invoking test find1");
            account = manager.find(Account.class, acctNum);
            if (account != null ) {
                pass = true;
            }
        } catch(Throwable e){
            e.printStackTrace();
        }

        return pass;
    }


    // Create a checking account
    public boolean create2() {
        
        boolean pass=false;

        Account account=null; 
        String accountType = "checking";

        // Account items
        String acctNum = "A10002";
        String name = "acct2";
        String description = "acct2des";
        String status = "open";
        String created = "Yes";
        String balance = "500";
        float  fBalance = 0;


        // BankAccount items
        String bankName = "Bank of America";
   
        // CheckingAccount items
        String overdraft = "no";

	account = new CheckingAccount();

        // set CheckingAccount items 
	((CheckingAccount)account).setIsOverDraftAllowed("yes".equalsIgnoreCase(overdraft));

        // set BankAccount items 
        ((BankAccount)account).setBankName(bankName);

        // set Account items 
        try{
            fBalance=Float.valueOf(balance);
        }catch(Exception ex){
            ex.printStackTrace();
        }
        account.setAcctNum(acctNum);
        account.setBalance(fBalance);
        account.setDescription(description);
        account.setName(name);
        account.setCreated(created);
        if ("open".equalsIgnoreCase(status)){
            account.setStatus(Account.Status.OPEN);
        }else{
            account.setStatus(Account.Status.CLOSED);
        }

        account2 = account;

        try {
            EntityTransaction tx = manager.getTransaction();
            tx.begin();            
            manager.persist(account);
            tx.commit();
            pass = true;
        } catch(Throwable e){
            e.printStackTrace();
        }
        return pass;
        
    }

    // Find the checking account
    public boolean find2() {
        
        boolean pass=false;

        Account account=null; 
        String acctNum = "A10002";

        try {
            account = manager.find(Account.class, acctNum);
            if (account != null ) {
                System.out.println(renderAccountDetails(account));
                pass = true;
            } 
        } catch(Throwable e){
            e.printStackTrace();
        }
	return pass;

    }

    // Create a VIP client and three agents
    public boolean create3() {
        
        boolean pass=false;

        // Client
        String clientId = "C1001";
        String clientInfoId = "CI1001";
        Boolean hasSaveBox = true;
        
        DummyClient vc = new VIPClient();
        vc.setClientId(clientId);
        vc.setClientSSN("111-11-1111");
        ((VIPClient)vc).setHasSaveBox(hasSaveBox);


        // AccountInfo
        vc.addAccount(account1);
        vc.addAccount(account2);

        // ClientInfo
        String name = "Sherry Shen";
        BaseInfo ci = new ClientInfo();
        ci.setId(clientInfoId);
        ci.setName(name);
        ((Info)ci).setProp1("ciProp1");
        ((ClientInfo)ci).setProp2("ciProp2");

        vc.setBaseInfo(ci);

        // Agent
        String agent1Name = "Sue Huang";
        String agent2Name = "Amy Wang";
        String agent3Name = "Ming Zhang";
        String location1 = "L101";
        String phone1 = "408-276-1111";
        String phone2 = "408-276-2222";
        String phone3 = "800-276-3333";
        String phone4 = "408-276-4444";
        Integer a1id1 = new Integer("101");
        String a1id2 = "agent1";
        String a2id = "a2a";
        String a2idb = "a2b";
        String a3id = "a3a";
        String a3idb = "a3b";

        VIPClientAgent va = new VIPClientAgentExt();
        va.setLocationId(location1);
        va.setAgentName(agent1Name);
        va.setPk1i(a1id1);
        va.setPk2s(a1id2);
        va.setOfficePhone(phone1);
        va.setCellPhone(phone2);
        ((VIPClientAgentExt)va).setExt1("a1Ext1");
        ((VIPClientAgentExt)va).setExt2("a1Ext2");
        ((VIPClient)vc).setVAgent(va);
        agent1 = va;

        PhoneAgent pa2 = new PhoneAgentExt();
        pa2.setLocationId(location1);
        pa2.setAgentName(agent2Name);
        PhoneAgentPK pA2PK= new PhoneAgentPK(a2id, a2idb);
        pa2.setPhoneAgentPK(pA2PK);
        pa2.setTollPhone(phone3);
        pa2.setLocalPhone(phone4);
        ((PhoneAgentExt)pa2).setExt1("a2Ext1");
        ((PhoneAgentExt)pa2).setExt2("a2Ext2");
        agent2 = pa2;

        PhoneAgent pa3 = new PhoneAgentExt();
        pa3.setLocationId(location1);
        pa3.setAgentName(agent3Name);
        PhoneAgentPK pA3PK= new PhoneAgentPK(a3id, a3idb);
        pa3.setPhoneAgentPK(pA3PK);
        pa3.setTollPhone(phone3);
        pa3.setLocalPhone(phone4);
        ((PhoneAgentExt)pa3).setExt1("a3Ext1");
        ((PhoneAgentExt)pa3).setExt2("a3Ext2");
        agent3 = pa3;

        Vector<PhoneAgent> pAgents = new Vector<PhoneAgent>();
        pAgents.add(agent2);
        pAgents.add(agent3);
        vc.setPAgents(pAgents);
        
        try {
            EntityTransaction tx = manager.getTransaction();
            tx.begin();            
	    manager.persist(agent1);
	    manager.persist(agent2);
	    manager.persist(agent3);
            manager.persist(vc);
            tx.commit();
            pass = true;
        } catch(Throwable e){
            e.printStackTrace();
        }
        return pass;
        
    }

    // find the vip client
    public boolean find3() {
        
        boolean pass=false;

        DummyClient client = null; 
        String clientId = "C1001";

        try {
            client = manager.find(DummyClient.class, clientId);
            if (client != null ) {
                System.out.println(renderClientDetails(client));
                pass = true;
            } 
        } catch(Throwable e){
            e.printStackTrace();
        }
	return pass;
    }

    // Create one more checking account
    public boolean create4() {
        
        boolean pass=false;

        Account account=null; 
        String accountType = "checking";

        // Account items
        String acctNum = "A10003";
        String name = "acct3";
        String description = "acct3des";
        String status = "close";
        String created = "Yes";
        String balance = "500";
        float  fBalance = 0;


        // BankAccount items
        String bankName = "Washington Mutual";
   
        // CheckingAccount items
        String overdraft = "no";

	account = new CheckingAccount();

        // set CheckingAccount items 
	((CheckingAccount)account).setIsOverDraftAllowed("yes".equalsIgnoreCase(overdraft));

        // set BankAccount items 
        ((BankAccount)account).setBankName(bankName);

        // set Account items 
        try{
            fBalance=Float.valueOf(balance);
        }catch(Exception ex){
            ex.printStackTrace();
        }
        account.setAcctNum(acctNum);
        account.setBalance(fBalance);
        account.setDescription(description);
        account.setName(name);
        account.setCreated(created);
        if ("open".equalsIgnoreCase(status)){
            account.setStatus(Account.Status.OPEN);
        }else{
            account.setStatus(Account.Status.CLOSED);
        }


        account3 = account;

        try {
            EntityTransaction tx = manager.getTransaction();
            tx.begin();            
            manager.persist(account);
            tx.commit();
            pass = true;            
        } catch(Throwable e){
            e.printStackTrace();
        }
        return pass;
        
    }

    public boolean find4() {
        
        boolean pass=false;

        Account account=null; 
        String acctNum = "A10003";

        try {
            account = manager.find(Account.class, acctNum);
            if (account != null ) {
                System.out.println(renderAccountDetails(account));
                pass = true;
            }
        } catch(Throwable e){
            e.printStackTrace();
        }

        return pass;
        
    }

    // Create a credit card account
    public boolean create5() {
        
        boolean pass=false;

        Account account=null; 
        String accountType = "creditcard";

        // Account items
        String acctNum = "A10004";
        String name = "acct4";
        String description = "acct4des";
        String status = "close";
        String created = "Yes";
        String balance = "500";
        float  fBalance = 0;

        // CreditCardAccount items
        String bankName = "Bank of America";
        String ccNum = "1111 2222 3333 4444";
   
	account = new CreditCardAccount();
        // set CreditCardAccount items 
	((CreditCardAccount)account).setCreditCardNumber(ccNum);
        ((CreditCardAccount)account).setIssuingBank(bankName);

        // set Account items 
        try{
            fBalance=Float.valueOf(balance);
        }catch(Exception ex){
            ex.printStackTrace();
        }
        account.setAcctNum(acctNum);
        account.setBalance(fBalance);
        account.setDescription(description);
        account.setName(name);
        account.setCreated(created);
        if ("open".equalsIgnoreCase(status)){
            account.setStatus(Account.Status.OPEN);
        }else{
            account.setStatus(Account.Status.CLOSED);
        }

        account4 = account;

        try {
            EntityTransaction tx = manager.getTransaction();
            tx.begin();            
            manager.persist(account);
            tx.commit();
            pass = true;            
        } catch(Throwable e){
            e.printStackTrace();
        }
        return pass;
        
    }


    // Create a brokerage account
    public boolean create6() {
        
        boolean pass=false;

        Account account=null; 
        String accountType = "brokerage";

        // Account items
        String acctNum = "A10005";
        String name = "acct5";
        String description = "acct5des";
        String status = "close";
        String created = "Yes";
        String balance = "500";
        float  fBalance = 0;

        // BrokerageAccount items
        float tradeFees = 5;
   
	account = new BrokerageAccount();

        // set BrokerageAccount items 
	((BrokerageAccount)account).setTradeFees(tradeFees);

        // set Account items 
        try{
            fBalance=Float.valueOf(balance);
        }catch(Exception ex){
            ex.printStackTrace();
        }
        account.setAcctNum(acctNum);
        account.setBalance(fBalance);
        account.setDescription(description);
        account.setName(name);
        account.setCreated(created);

        if ("open".equalsIgnoreCase(status)){
            account.setStatus(Account.Status.OPEN);
        }else{
            account.setStatus(Account.Status.CLOSED);
        }

        account5 = account;

        try {
            EntityTransaction tx = manager.getTransaction();
            tx.begin();            
            manager.persist(account);
            tx.commit();
            pass = true;            
        } catch(Throwable e){
            e.printStackTrace();
        }
        return pass;
        
    }


    // Create a credit card account
    public boolean create7() {
        
        boolean pass=false;

        Account account=null; 
        String accountType = "margin";

        // Account items
        String acctNum = "A10006";
        String name = "acct6";
        String description = "acct6des";
        String status = "close";
        String created = "Yes";
        String balance = "500";
        float  fBalance = 0;

        // MarginAccount items
        float tradeFees = 5;
        float maxLoan = 1000;
   
	account = new MarginAccount();

        // set MarginAccount items 
	((MarginAccount)account).setMaxLoanAllowed(maxLoan);
	((MarginAccount)account).setTradeFees(tradeFees);

   
        // set Account items 
        try{
            fBalance=Float.valueOf(balance);
        }catch(Exception ex){
            ex.printStackTrace();
        }
        account.setAcctNum(acctNum);
        account.setBalance(fBalance);
        account.setDescription(description);
        account.setName(name);
        account.setCreated(created);
        if ("open".equalsIgnoreCase(status)){
            account.setStatus(Account.Status.OPEN);
        }else{
            account.setStatus(Account.Status.CLOSED);
        }

        account6 = account;

        try {
            EntityTransaction tx = manager.getTransaction();
            tx.begin();            
            manager.persist(account);
            tx.commit();
            pass = true;
        } catch(Throwable e){
            e.printStackTrace();
        }
        return pass;
        
    }

    // Create a regular client
    public boolean create8() {
        
        boolean pass=false;

        // Client
        String clientId = "C1002";
        String clientInfoId = "CI1002";
        Boolean hasCreditCard = true;
        
        DummyClient rc1 = new RegularClient();
        rc1.setClientId(clientId);
        rc1.setClientSSN("111-11-1112");
        ((RegularClient)rc1).setHasCreditCard(hasCreditCard);


        // AccountInfo
        // rc1.addAccount(account3); removed
        rc1.addAccount(account4);

        // ClientInfo
        String name = "Richard Hill";
        BaseInfo ci = new ClientInfo();
        ci.setId(clientInfoId);
        ci.setName(name);
        ((Info)ci).setProp1("ci2Prop1");
        ((ClientInfo)ci).setProp2("ci2Prop2");
        rc1.setBaseInfo(ci);

        Vector<PhoneAgent> pAgents = new Vector<PhoneAgent>();
        pAgents.add(agent2);
        rc1.setPAgents(pAgents);
        
        try {
            EntityTransaction tx = manager.getTransaction();
            tx.begin();            
            manager.persist(rc1);
            tx.commit();
            pass = true;
        } catch(Throwable e){
            e.printStackTrace();
        }
        return pass;
        
    }

    // find the regular client
    public boolean find8() {
        
        boolean pass=false;

        DummyClient client = null; 
        String clientId = "C1002";

        try {
            client = manager.find(DummyClient.class, clientId);
            if (client != null ) {
                System.out.println(renderClientDetails(client));
                pass = true;
            } 
        } catch(Throwable e){
            e.printStackTrace();
        }
	return pass;
    }


    // Create another regular client
    public boolean create9() {
        
        boolean pass=false;

        // Client
        String clientId = "C1003";
        String clientInfoId = "CI1003";
        Boolean hasCreditCard = false;
        
        DummyClient rc2 = new RegularClient();
        rc2.setClientId(clientId);
        rc2.setClientSSN("111-11-1113");
        ((RegularClient)rc2).setHasCreditCard(hasCreditCard);


        // AccountInfo
        rc2.addAccount(account5);
        rc2.addAccount(account6);

        // ClientInfo
        String name = "Suzie Hill";
        BaseInfo ci = new ClientInfo();
        ci.setId(clientInfoId);
        ci.setName(name);
        ((Info)ci).setProp1("ci3Prop1");
        ((ClientInfo)ci).setProp2("ci3Prop2");
        rc2.setBaseInfo(ci);

        Vector<PhoneAgent> pAgents = new Vector<PhoneAgent>();
        pAgents.add(agent2);
        pAgents.add(agent3);
        rc2.setPAgents(pAgents);
        
        try {
            EntityTransaction tx = manager.getTransaction();
            tx.begin();            
            manager.persist(rc2);
            tx.commit();
            pass = true;
        } catch(Throwable e){
            e.printStackTrace();
        }
        return pass;
        
    }

    // find the regular client's info (another polymophere query)
    public boolean find9() {
        
        boolean pass=false;
        BaseInfo info = null;
        String clientInfoId = "CI1003";

        try {
            info = manager.find(BaseInfo.class, clientInfoId);
            if (info != null ) {
                System.out.println(renderClientInfo(info));
                pass = true;
            } 
        } catch(Throwable e){
            e.printStackTrace();
        }
	return pass;
    }

    public boolean update4() {
        
        boolean pass=false;

        Account account=null; 
        String acctNum = "A10003";
        String name = "checking-3";
        String status = "close";
        // CheckingAccount items
        String overdraft = "yes";

        try {
	    manager.getTransaction().begin();
            account = manager.find(Account.class, acctNum);
            // change items 
            account.setName(name);
            if ("open".equalsIgnoreCase(status)){
                account.setStatus(Account.Status.OPEN);
            }else{
                account.setStatus(Account.Status.CLOSED);
            }
   	    ((CheckingAccount)account).setIsOverDraftAllowed(
               "yes".equalsIgnoreCase(overdraft));
            manager.merge(account);
            manager.getTransaction().commit();
            pass = true;
        } catch(Throwable e){
            e.printStackTrace();
        }

        return pass;
        
    }

    public boolean remove4() {
        
        boolean pass=false;
        Account account=null; 
        String acctNum = "A10003";

        try {
	    manager.getTransaction().begin();
            account = manager.find(Account.class, acctNum);
            manager.remove(account);
            manager.getTransaction().commit();
            pass = true;
        } catch(Throwable e){
            e.printStackTrace();
        }
        return pass;
        
    }


    public boolean native1() {
        
        boolean pass=false;
        String sqlString;
        Query q;
        List result;
        int size;
        int count = 0;


        try {
            // verify annotation @DiscriminatorColumn(name="DCOL")
            sqlString="SELECT a.DCOL from ACCOUNT a";
            q = manager.createNativeQuery(sqlString);
            result = q.getResultList();
            size = result.size();
            System.out.println("size of DCOL from ACCOUNT: " + size);
            System.out.println("result: " + result);
            if (size > 0) {
                count++;
            } 

            // verify attribute override
            // from BANKNAME to BANK_NAME
            sqlString="SELECT ca.BANK_NAME from ACCOUNT ca";
            q = manager.createNativeQuery(sqlString);
            result = q.getResultList();
            size = result.size();
            System.out.println("size of BANK_NAME from ACCOUNT: " + size);
            System.out.println("result: " + result);
            if (size > 0) {
                count++;
            } 
            sqlString="SELECT sa.BANKNAME from ACCOUNT sa";
            q = manager.createNativeQuery(sqlString);
            result = q.getResultList();
            size = result.size();
            System.out.println("size of BANKNAME from ACCOUNT: " + size);
            System.out.println("result: " + result);
            if (size > 0) {
                count++;
            } 

            // verify association override
            // from BASE_INFO to CLIENT_INFO
            sqlString="SELECT dc.CLIENT_INFO from DUMMYCLIENT dc";
            q = manager.createNativeQuery(sqlString);
            result = q.getResultList();
            size = result.size();
            System.out.println("size of CLIENT_INFO from DUMMYCLIENT: " + size);
            if (size > 0) {
                count++;
            } 

            // verify XML override on annontation
            // from Single Table B_INFO by annotation to Joined 
            // BASE_INFO and C_INFO by Orm.xml
            sqlString="SELECT bi.INFO_TYPE from BASE_INFO bi";
            q = manager.createNativeQuery(sqlString);
            result = q.getResultList();
            size = result.size();
            System.out.println("size of INFO_TYPE from BASE_INFO: " + size);
            if (size > 0) {
                count++;
            } 
            sqlString="SELECT ci.INFO_ID from C_INFO ci";
            q = manager.createNativeQuery(sqlString);
            result = q.getResultList();
            size = result.size();
            System.out.println("size of INFO_ID from C_INFO: " + size);
            if (size > 0) {
                count++;
            } 
            System.out.println("count = " + count);
            if (count == 6) {
                pass = true;
            }
        } catch(Throwable e){
            e.printStackTrace();
        }
	return pass;
    }


    public boolean jpaql1() {
        
        boolean pass=false;
        String sqlStr;
        String p1, v1;
        List result;
        int size;
        int count = 0;

        try {
            // verify jpa query
            sqlStr = "SELECT a From Account a WHERE a.name like :acctName";
            p1 = "acctName";
            v1 = "acct1";
            result = jpaqlFindByStr(sqlStr, p1, v1);          
            size = result.size();
            System.out.println("size of AccountByName: " + size);
            System.out.println("result: " + result);
            if (size > 0) {
                count++;
            } 

            // verify query of enum
            sqlStr = "SELECT a From Account a WHERE a.status = :acctStatus";
            p1 = "acctStatus";
            result = jpaqlFindByEnum(sqlStr, p1, Account.Status.OPEN);
            size = result.size();
            System.out.println("size of Account by Status: " + size);
            System.out.println("result: " + result);
            if (size > 0) {
                count++;
            } 

            if (count == 2) {
                pass = true;
            }

        } catch(Throwable e){
            e.printStackTrace();
        }
	return pass;
    }

    private List jpaqlFindByEnum(String sqlStr, String p, Account.Status v){
       return manager.createQuery(sqlStr)
       .setParameter(p, v)
       .setMaxResults(10)
       .getResultList();
    }
    

    private List jpaqlFindByStr(String sqlStr, String p, String v){
       return manager.createQuery(sqlStr)
       .setParameter(p, v)
       .setMaxResults(10)
       .getResultList();
    }


    public boolean jpaql2() {
        
        boolean pass=false;
        String sqlStr;
        String p1, v1, p2, v2;
        int size;
        int count = 0;


        try {
	    // "No tranaction is currently active" exception in 9.1pe_b50
	    //  Bulk updates are supposed to be executed inside a transaction
	    //  according to executionUpdate() in section 3.6.1.
	    //  Early version (e.g. 9.1pe_b21) did not validate this.
	    //  Revise test case
            manager.getTransaction().begin();
            // update enum from jpa ql
            sqlStr = "Update Account a SET a.name = :acctName WHERE a.acctNum = :acctNum";
            p1 = "acctNum";
            v1 = "A10001";
            p2 = "acctName";
            v2 = "savings-sherry";
            size = jpaqlUpdateStr(sqlStr, p1, v1, p2, v2);
            System.out.println("size of updating Account Name: " + size);
            if (size > 0) {
                count++;
            } 
            v1 = "A10002";
            v2 = "checking-sherry";
            size = jpaqlUpdateStr(sqlStr, p1, v1, p2, v2);
            System.out.println("size of updating Account Name: " + size);
            if (size > 0) {
                count++;
            } 

            sqlStr = "Update Account a SET a.status = :acctStatus WHERE LOCATE(:acctName, a.name) > 0 ";
            p1 = "acctStatus";
            p2 = "acctName";
            v2 = "sherry";
            size = jpaqlUpdateEnum(sqlStr, p1, Account.Status.OPEN, p2, v2);
            System.out.println("size of updated Account Status: " + size);
            if (size > 0) {
                count++;
            } 
	    manager.getTransaction().commit();            

            if (count == 3) {
                pass = true;
            } 

        } catch(Throwable e){
            e.printStackTrace();
        }
	return pass;
    }
    
    private int jpaqlUpdateEnum(String sqlStr, String p1, Account.Status v1,
			       String p2, String v2){
       Query q = manager.createQuery(sqlStr);
       q.setParameter(p1, v1);
       q.setParameter(p2, v2); 
       return q.executeUpdate();
      
    }

    private int jpaqlUpdateStr(String sqlStr, String p1, String v1,
			       String p2, String v2){
       Query q = manager.createQuery(sqlStr);
       q.setParameter(p1, v1);
       q.setParameter(p2, v2); 
       return q.executeUpdate();
      
    }

    private String renderAccountDetails(Account account){
        
        StringBuffer sb = new StringBuffer();
        
        sb.append("Account Number: ").append(account.getAcctNum()).append("\n");
        sb.append("Name: ").append(account.getName()).append("\n");
        sb.append("Status: ").append(account.getStatus()==Account.Status.OPEN?"Open":"Closed").append("\n");
        sb.append("Description: ").append(account.getDescription()).append("\n");
        sb.append("Balance:").append(account.getBalance()).append("\n");
        
        if(account instanceof CheckingAccount){
            
            sb.append("Overdraft allowed: ").append(((CheckingAccount)account).isIsOverDraftAllowed()==true?"Yes":"No").append("\n");
        
        }else if(account instanceof SavingsAccount){
            
            sb.append("Savings Rate: ").append(((SavingsAccount)account).getSavingsRate()).append("\n");
            
        }else if(account instanceof CreditCardAccount){
            sb.append("Credit Card Number: ").append(((CreditCardAccount)account).getCreditCardNumber()).append("\n");
            sb.append("Issuing Bank: ").append(((CreditCardAccount)account).getIssuingBank()).append("\n");
        
        }else if (account instanceof MarginAccount){
            
            sb.append("Trading Fees: ").append(((MarginAccount)account).getTradeFees()).append("\n");
            sb.append("Max loan allowed: ").append(((MarginAccount)account).getMaxLoanAllowed()).append("\n");
        
        }else if (account instanceof BrokerageAccount){
            sb.append("Trading Fees: ").append(((BrokerageAccount)account).getTradeFees()).append("\n");
        }        
        return sb.toString();
        
    }

    private String renderClientDetails(DummyClient client){
        
        StringBuffer sb = new StringBuffer();

        sb.append("Client ID: ").append(client.getClientId()).append("\n");
        sb.append("Client SSN: ").append(client.getClientSSN()).append("\n");
        
        if(client instanceof VIPClient){
            
            sb.append("hasSaveBox: ").append(((VIPClient)client).getHasSaveBox()==true?"Yes":"No").append("\n");
            VIPClientAgent vAgent = ((VIPClient)client).getVAgent();
            if (vAgent != null) {
                sb.append("VIPClientAgent-Name: ").append(vAgent.getAgentName()).append("\n");
                sb.append("VIPClientAgent-Cell Phone: ").append(vAgent.getCellPhone()).append("\n");
                sb.append("VIPClientAgent-Ext2: ").append(((VIPClientAgentExt)vAgent).getExt2()).append("\n");
	    }
        }else if(client instanceof RegularClient){
            
            sb.append("Has Credit Card: ").append(((RegularClient)client).getHasCreditCard()).append("\n");
        }        

        sb.append(renderClientInfo(client.getBaseInfo()));

        Collection accounts = client.getAccounts();
        Iterator it = accounts.iterator();
        while (it.hasNext()) {
           Account acct = (Account) it.next();
           String des = acct.getDescription();
           sb.append("Account Description: ").append(des).append("\n");
	}

        Collection agents = client.getPAgents();
        it = agents.iterator();
        while (it.hasNext()) {
           PhoneAgent agent = (PhoneAgent) it.next();
           sb.append("Phone Agent - Name: ").append(agent.getAgentName()).append("\n");
           sb.append("Phone Agent - TollPhone: ").append(agent.getTollPhone()).append("\n");
           sb.append("Phone Agent - Ext1: ").append(((PhoneAgentExt)agent).getExt1()).append("\n");
	}


        return sb.toString();
        
    }

    private String renderClientInfo(BaseInfo ci){
        
        StringBuffer sb = new StringBuffer();

        sb.append("Info - Name: ").append(ci.getName()).append("\n");
        sb.append("Info - Prop1: ").append(((Info)ci).getProp1()).append("\n");
        sb.append("Info - Prop2: ").append(((ClientInfo)ci).getProp2()).append("\n");
        return sb.toString();
        
    }

   
    public boolean executeTest(String testname, Object test) {
	Method m=null;
	boolean ret=false;  
	
	try {
	  m = ejb30.inherit.client.outside.TestClient.class.getMethod(testname, new Class[] {});
	  Object[] arg = {};
	  ret = (Boolean) m.invoke(test, (Object[])null);     
	} catch (Exception ex){
	  ex.printStackTrace();
	}

	return ret;

     } 
    

    public void doClose() {
	   
	manager.close();
        emf.close();

    }

    public static void main(String[] args) {    

	SimpleReporterAdapter stat = new SimpleReporterAdapter("appserver-sqe");   
	stat.addDescription("EJB3 Inheritance Tests");	   
        String testSuiteID = args[0];

        System.out.println("main, testSuiteID="+testSuiteID);

       	String testlist[]={"create1",
                           "find1",
                           "create2",
                           "find2",
                           "create3",
                           "find3",
                           "create4",
                           "update4",
                           "find4",
                           "remove4",
                           "create5",
                           "create6",
                           "create7",
                           "create8",
                           "find8",
                           "create9",
                           "find9",
                           "native1",
                           "jpaql1",
                           "jpaql2"};  


        if (args.length == 1) {
           testSuiteID=args[0];
        } 

        TestClient tc = new TestClient();

	for (int i=0; i < testlist.length; i++){
	  String testname=testlist[i];
          System.out.println("...invoking test" + (i+1) + ": " + testname);
	  boolean result = tc.executeTest(testname, tc);
	  if (result == true)  {
	    stat.addStatus(testSuiteID + testname, stat.PASS);
	  } else {
	    stat.addStatus(testSuiteID + testname, stat.FAIL);
	  }
          System.out.println("...finished "+testname+", passed = "+result);
	}
		
	stat.printSummary(); 
	tc.doClose();

    }
    
}
