/*
 * Account.java
 */

package ejb30.inherit.entity;

import javax.persistence.*;
import ejb30.inherit.common.*;

@Entity
@Inheritance(strategy=InheritanceType.SINGLE_TABLE)
@DiscriminatorColumn(name="DCOL")
public abstract class Account  extends BaseAccount
       implements java.io.Serializable {

 // issues 634, 193, 899
 public enum Status { OPEN, CLOSED}


 private  String acctNum;  
 private  String name;
 private  String created;
 private  Status status; //Open/Close
 private  float balance; 
 private  String description;

 public Account(){
     
 }

    @Id
    @Column(length=55)
    public String getAcctNum() {
        return this.acctNum;
    }

    public void setAcctNum(String acctNum) {
        this.acctNum = acctNum;
    }


    @Column(length=55)
    public String getName() {
        return this.name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Column(length=55)
    public String getCreated() {
        return this.created;
    }

    public void setCreated(String created) {
        this.created = created;
    }

    // v2 b20 verify issue 634
    public Status getStatus() {
        return this.status;
    }

    public void setStatus(Status status) {
        this.status = status;
    }

    public float getBalance() {
        return this.balance;
    }

    public void setBalance(float balance) {
        this.balance = balance;
    }

    @Column(length=55)
    public String getDescription() {
        return this.description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

 
}




