package ejb30.inherit.session;

import javax.persistence.EntityManager;
import javax.annotation.*;
import javax.ejb.*;
import java.util.*;
import javax.persistence.*;
import java.text.*;
import ejb30.inherit.entity.*;

@Stateless
@Remote({ejb30.inherit.session.SessionRemote.class})

public class SessionBean implements SessionRemote {
    
    @PersistenceContext (unitName="inherit") EntityManager em;

    public Account findAccount(String acctNum) {
      Account account=null;
      try {
          account = em.find(Account.class, acctNum);
      } catch(Exception ex){
          ex.printStackTrace();
      }
      return account;
    }

    public DummyClient findClient(String clientId) {
      DummyClient client=null;
      try {
          client = em.find(DummyClient.class, clientId);
      } catch(Exception ex){
          ex.printStackTrace();
      }
      return client;
    }
    
    public BaseInfo findInfo(String infoId) {
      BaseInfo info =null;
      try {
          info = em.find(BaseInfo.class, infoId);
      } catch(Exception ex){
          ex.printStackTrace();
      }
      return info;
    }

    public boolean persistRemote(Object obj){
      boolean done=false;
      try {        
          em.persist(obj);
          done = true;
      } catch(Exception ex){
          ex.printStackTrace();
      }
      return done;
    }
    

    public boolean mergeRemote(Object obj){
      boolean done=false;
      try {        
          em.merge(obj);
          done = true;
      } catch(Exception ex){
          ex.printStackTrace();
      }
      return done;
    }

    public boolean removeRemote(Object obj){
      boolean done=false;
      try {        
          Object toDelete = em.merge(obj);
          em.remove(toDelete);
          done = true;
      } catch(Exception ex){
          ex.printStackTrace();
      }
      return done;
    }


    public List nativeQuery(String sqlStr) {
      List result = null;
      Query q = null;
      try {
          q = em.createNativeQuery(sqlStr);
          result = q.getResultList();
      } catch(Exception ex){
          ex.printStackTrace();
      }
      return result;
    }

    public List jpaqlFindByStr(String sqlStr, String p1, String v1) {
      List result = null;
      Query q = null;
      try {
          q = em.createQuery(sqlStr);
          q.setParameter(p1, v1);
          result = q.getResultList();
      } catch(Exception ex){
          ex.printStackTrace();
      }
      return result;
    }

    public List jpaqlFindByEnum(String sqlStr, String p1, Account.Status v1){
      List result = null;
      Query q = null;
      try {
          q = em.createQuery(sqlStr);
          q.setParameter(p1, v1);
          result = q.getResultList();
      } catch(Exception ex){
          ex.printStackTrace();
      }
      return result;
    }

    public int jpaqlUpdateStr(String sqlStr, String p1, String v1, 
			 String p2, String v2) {
      int  result = 0;
      Query q = null;
      try {
          q = em.createQuery(sqlStr);
          q.setParameter(p1, v1);
          q.setParameter(p2, v2);
          result = q.executeUpdate();
      } catch(Exception ex){
          ex.printStackTrace();
      }
      return result;
    }

    public int jpaqlUpdateEnum(String sqlStr, String p1, Account.Status v1, 
			 String p2, String v2) {
      int result = 0;
      Query q = null;
      try {
          q = em.createQuery(sqlStr);
          q.setParameter(p1, v1);
          q.setParameter(p2, v2);
          result = q.executeUpdate();
      } catch(Exception ex){
          ex.printStackTrace();
      }
      return result;
    }

}    








