ALTER TABLE CLIENT_PHONEAGENT DROP CONSTRAINT CLENTPHONEAGENTPD2;
ALTER TABLE CLIENT_PHONEAGENT DROP CONSTRAINT CLIENTPHONEAGENTCD;
ALTER TABLE DUMMYCLIENT DROP CONSTRAINT DMMYCLIENTCLNTINFO;
ALTER TABLE DUMMYCLIENT DROP CONSTRAINT DUMMYCLIENT_FK_VA1;
ALTER TABLE CLIENT_ACCT DROP CONSTRAINT CLIENT_ACCT_C_ID;
ALTER TABLE CLIENT_ACCT DROP CONSTRAINT CLIENT_ACCT_A_ID;
ALTER TABLE PHONEAGENTEXT DROP CONSTRAINT PHONEAGENTEXTPAPK2;
ALTER TABLE C_INFO DROP CONSTRAINT FK_C_INFO_INFO_ID;

DROP TABLE CLIENT_PHONEAGENT;
DROP TABLE VIPCLIENTAGENT;
DROP TABLE BASE_INFO;
DROP TABLE DUMMYCLIENT;
DROP TABLE CLIENT_ACCT;
DROP TABLE ACCOUNT;
DROP TABLE PHONEAGENT;
DROP TABLE PHONEAGENTEXT;
DROP TABLE C_INFO;

CREATE TABLE CLIENT_PHONEAGENT (C_ID VARCHAR(55) NOT NULL, 
       PA_ID1 VARCHAR(55) NOT NULL, PA_ID2 VARCHAR(55) NOT NULL,   
       PRIMARY KEY (C_ID, PA_ID1, PA_ID2));

CREATE TABLE VIPCLIENTAGENT (PK1I INTEGER NOT NULL, 
       PK2S VARCHAR(55) NOT NULL, DTYPE VARCHAR(31), 
       LOCATIONID VARCHAR(55), OFFICEPHONE VARCHAR(55), 
       CELLPHONE VARCHAR(55), AGENTNAME VARCHAR(55), 
       EXT1 VARCHAR(55), EXT2 VARCHAR(55), PRIMARY KEY (PK1I, PK2S));

CREATE TABLE BASE_INFO (ID VARCHAR(55) NOT NULL, INFO_TYPE VARCHAR(31),
       NAME VARCHAR(55), PRIMARY KEY (ID));

CREATE TABLE DUMMYCLIENT (CLIENTID VARCHAR(55) NOT NULL, 
       DTYPE VARCHAR(31), CLIENTSSN VARCHAR(55), 
       CLIENT_INFO VARCHAR(55), HASCREDITCARD SMALLINT DEFAULT 0, 
       HASSAVEBOX SMALLINT DEFAULT 0, FK_VA1 INTEGER, FK_VA2 VARCHAR(55), 
       PRIMARY KEY (CLIENTID));

CREATE TABLE CLIENT_ACCT (C_ID VARCHAR(55) NOT NULL, 
       A_ID VARCHAR(55) NOT NULL, PRIMARY KEY (C_ID, A_ID));

CREATE TABLE ACCOUNT (ACCTNUM VARCHAR(55) NOT NULL, DCOL VARCHAR(31), 
       CREATED VARCHAR(55), STATUS INTEGER, BALANCE FLOAT, 
       NAME VARCHAR(55), DESCRIPTION VARCHAR(55), BANK_NAME VARCHAR(50), 
       ISOVERDRAFTALLOWED SMALLINT DEFAULT 0, BANKNAME VARCHAR(55), 
       SAVINGSRATE FLOAT, TRADEFEES FLOAT, CREDITCARDNUMBER VARCHAR(55), 
       ISSUINGBANK VARCHAR(55), EXPIRESON VARCHAR(55), 
       MAXLOANALLOWED FLOAT, PRIMARY KEY (ACCTNUM));

CREATE TABLE PHONEAGENT (DTYPE VARCHAR(31), AGENTNAME VARCHAR(55), 
       LOCATIONID VARCHAR(55), LOCALPHONE VARCHAR(55), 
       TOLLPHONE VARCHAR(55), PK2 VARCHAR(55) NOT NULL, 
       PK1 VARCHAR(55) NOT NULL, PRIMARY KEY (PK2, PK1));

CREATE TABLE PHONEAGENTEXT (PA_PK1 VARCHAR(55) NOT NULL, 
       PA_PK2 VARCHAR(55) NOT NULL, EXT1 VARCHAR(55), EXT2 VARCHAR(55), 
       PRIMARY KEY (PA_PK1, PA_PK2));

CREATE TABLE C_INFO (INFO_ID VARCHAR(55) NOT NULL, PROP2 VARCHAR(55), 
       PRIMARY KEY (INFO_ID));

ALTER TABLE CLIENT_PHONEAGENT ADD CONSTRAINT CLENTPHONEAGENTPD2 
      FOREIGN KEY (PA_ID2, PA_ID1) REFERENCES PHONEAGENT (PK2, PK1);

ALTER TABLE CLIENT_PHONEAGENT ADD CONSTRAINT CLIENTPHONEAGENTCD
      FOREIGN KEY (C_ID) REFERENCES DUMMYCLIENT (CLIENTID);

ALTER TABLE DUMMYCLIENT ADD CONSTRAINT DMMYCLIENTCLNTINFO 
      FOREIGN KEY (CLIENT_INFO) REFERENCES BASE_INFO (ID);

ALTER TABLE DUMMYCLIENT ADD CONSTRAINT DUMMYCLIENT_FK_VA1 
      FOREIGN KEY (FK_VA1, FK_VA2) REFERENCES VIPCLIENTAGENT (PK1I, PK2S);

ALTER TABLE CLIENT_ACCT ADD CONSTRAINT CLIENT_ACCT_C_ID 
      FOREIGN KEY (C_ID) REFERENCES DUMMYCLIENT (CLIENTID);

ALTER TABLE CLIENT_ACCT ADD CONSTRAINT CLIENT_ACCT_A_ID 
      FOREIGN KEY (A_ID) REFERENCES ACCOUNT (ACCTNUM);

ALTER TABLE PHONEAGENTEXT ADD CONSTRAINT PHONEAGENTEXTPAPK2 
      FOREIGN KEY (PA_PK2, PA_PK1) REFERENCES PHONEAGENT (PK2, PK1);

ALTER TABLE C_INFO ADD CONSTRAINT FK_C_INFO_INFO_ID 
      FOREIGN KEY (INFO_ID) REFERENCES BASE_INFO (ID);

