DROP TABLE CLIENT_PHONEAGENT CASCADE;
COMMIT;
DROP TABLE VIPCLIENTAGENT CASCADE;
COMMIT;
DROP TABLE BASE_INFO CASCADE;
COMMIT;
DROP TABLE DUMMYCLIENT CASCADE;
COMMIT;
DROP TABLE CLIENT_ACCT CASCADE;
COMMIT;
DROP TABLE ACCOUNT CASCADE;
COMMIT;
DROP TABLE PHONEAGENT CASCADE;
COMMIT;
DROP TABLE PHONEAGENTEXT CASCADE;
COMMIT;
DROP TABLE C_INFO CASCADE;
COMMIT;

CREATE TABLE CLIENT_PHONEAGENT (C_ID VARCHAR(255) NOT NULL, 
       PA_ID1 VARCHAR(255) NOT NULL, PA_ID2 VARCHAR(255) NOT NULL, 
       PRIMARY KEY (C_ID, PA_ID1, PA_ID2));

CREATE TABLE VIPCLIENTAGENT (PK1I INTEGER NOT NULL, 
       PK2S VARCHAR(255) NOT NULL, DTYPE VARCHAR(31), 
       LOCATIONID VARCHAR(255), OFFICEPHONE VARCHAR(255), 
       CELLPHONE VARCHAR(255), AGENTNAME VARCHAR(255), 
       EXT1 VARCHAR(255), EXT2 VARCHAR(255), PRIMARY KEY (PK1I, PK2S));

CREATE TABLE BASE_INFO (ID VARCHAR(255) NOT NULL, 
       INFO_TYPE VARCHAR(31), NAME VARCHAR(255), PRIMARY KEY (ID));

CREATE TABLE DUMMYCLIENT (CLIENTID VARCHAR(255) NOT NULL, 
       DTYPE VARCHAR(31), CLIENTSSN VARCHAR(255), 
       CLIENT_INFO VARCHAR(255), HASSAVEBOX BOOLEAN, 
       FK_VA1 INTEGER, FK_VA2 VARCHAR(255), HASCREDITCARD BOOLEAN, 
       PRIMARY KEY (CLIENTID));

CREATE TABLE CLIENT_ACCT (C_ID VARCHAR(255) NOT NULL, 
       A_ID VARCHAR(255) NOT NULL, PRIMARY KEY (C_ID, A_ID));

CREATE TABLE ACCOUNT (ACCTNUM VARCHAR(255) NOT NULL, DCOL VARCHAR(31),
       BALANCE FLOAT, NAME VARCHAR(255), CREATED VARCHAR(255), 
       DESCRIPTION VARCHAR(255), STATUS INTEGER, BANK_NAME VARCHAR(255), 
       ISOVERDRAFTALLOWED BOOLEAN, BANKNAME VARCHAR(255), 
       SAVINGSRATE FLOAT, TRADEFEES FLOAT, MAXLOANALLOWED FLOAT, 
       CREDITCARDNUMBER VARCHAR(255), ISSUINGBANK VARCHAR(255), 
       EXPIRESON VARCHAR(255), PRIMARY KEY (ACCTNUM));

CREATE TABLE PHONEAGENT (DTYPE VARCHAR(31), AGENTNAME VARCHAR(255),
       LOCATIONID VARCHAR(255), LOCALPHONE VARCHAR(255), 
       TOLLPHONE VARCHAR(255), PK1 VARCHAR(255) NOT NULL, 
       PK2 VARCHAR(255) NOT NULL, PRIMARY KEY (PK1, PK2));

CREATE TABLE PHONEAGENTEXT (PA_PK1 VARCHAR(255) NOT NULL, 
       PA_PK2 VARCHAR(255) NOT NULL, EXT1 VARCHAR(255), 
       EXT2 VARCHAR(255), PRIMARY KEY (PA_PK1, PA_PK2));
CREATE TABLE C_INFO (INFO_ID VARCHAR(255) NOT NULL, 
       PROP2 VARCHAR(255), PRIMARY KEY (INFO_ID));

ALTER TABLE CLIENT_PHONEAGENT ADD CONSTRAINT 
      FK_CLIENT_PHONEAGENT_C_ID FOREIGN KEY (C_ID) 
      REFERENCES DUMMYCLIENT (CLIENTID);

ALTER TABLE CLIENT_PHONEAGENT ADD CONSTRAINT 
      FK_CLIENT_PHONEAGENT_PA_ID FOREIGN KEY 
      (PA_ID1, PA_ID2) REFERENCES PHONEAGENT (PK1, PK2);

ALTER TABLE DUMMYCLIENT ADD CONSTRAINT FK_DUMMYCLIENT_CLIENT_INFO 
      FOREIGN KEY (CLIENT_INFO) REFERENCES BASE_INFO (ID);

ALTER TABLE DUMMYCLIENT ADD CONSTRAINT FK_DUMMYCLIENT_FK_VA
      FOREIGN KEY (FK_VA1, FK_VA2) REFERENCES VIPCLIENTAGENT (PK1I, PK2S);

ALTER TABLE CLIENT_ACCT ADD CONSTRAINT FK_CLIENT_ACCT_C_ID 
      FOREIGN KEY (C_ID) REFERENCES DUMMYCLIENT (CLIENTID);

ALTER TABLE CLIENT_ACCT ADD CONSTRAINT FK_CLIENT_ACCT_A_ID 
      FOREIGN KEY (A_ID) REFERENCES ACCOUNT (ACCTNUM);

ALTER TABLE PHONEAGENTEXT ADD CONSTRAINT FK_PHONEAGENTEXT_PA_PK
      FOREIGN KEY (PA_PK1, PA_PK2) REFERENCES PHONEAGENT (PK1, PK2);

ALTER TABLE C_INFO ADD CONSTRAINT FK_C_INFO_INFO_ID 
      FOREIGN KEY (INFO_ID) REFERENCES BASE_INFO (ID);
