ALTER TABLE CLIENT_PHONEAGENT DROP CONSTRAINT CLIENT_PHONEAGENT_C_ID;
ALTER TABLE CLIENT_PHONEAGENT DROP CONSTRAINT CLIENTPHONEAGENTPA_ID;
ALTER TABLE DUMMYCLIENT DROP CONSTRAINT DUMMYCLIENTCLIENT_INFO;
ALTER TABLE DUMMYCLIENT DROP CONSTRAINT FK_DUMMYCLIENT_FK_VA;
ALTER TABLE CLIENT_ACCT DROP CONSTRAINT FK_CLIENT_ACCT_C_ID;
ALTER TABLE CLIENT_ACCT DROP CONSTRAINT FK_CLIENT_ACCT_A_ID;
ALTER TABLE PHONEAGENTEXT DROP CONSTRAINT PHONEAGENTEXT_PA_PK;
ALTER TABLE C_INFO DROP CONSTRAINT FK_C_INFO_INFO_ID;

DROP TABLE CLIENT_PHONEAGENT;
DROP TABLE VIPCLIENTAGENT;
DROP TABLE BASE_INFO;
DROP TABLE DUMMYCLIENT;
DROP TABLE CLIENT_ACCT;
DROP TABLE ACCOUNT;
DROP TABLE PHONEAGENT;
DROP TABLE PHONEAGENTEXT;
DROP TABLE C_INFO;

CREATE TABLE CLIENT_PHONEAGENT (C_ID VARCHAR(55) NOT NULL, 
       PA_ID1 VARCHAR(55) NOT NULL, PA_ID2 VARCHAR(55) NOT NULL, 
       PRIMARY KEY (C_ID, PA_ID1, PA_ID2));

CREATE TABLE VIPCLIENTAGENT (PK1I INTEGER NOT NULL, 
       PK2S VARCHAR(55) NOT NULL, DTYPE VARCHAR(31) NULL, 
       LOCATIONID VARCHAR(55) NULL, OFFICEPHONE VARCHAR(55) NULL, 
       CELLPHONE VARCHAR(55) NULL, AGENTNAME VARCHAR(55) NULL, 
       EXT1 VARCHAR(55) NULL, EXT2 VARCHAR(55) NULL, 
       PRIMARY KEY (PK1I, PK2S));

CREATE TABLE BASE_INFO (ID VARCHAR(55) NOT NULL, 
       INFO_TYPE VARCHAR(31) NULL, NAME VARCHAR(55) NULL, 
       PRIMARY KEY (ID));

CREATE TABLE DUMMYCLIENT (CLIENTID VARCHAR(55) NOT NULL, 
       DTYPE VARCHAR(31) NULL, CLIENTSSN VARCHAR(55) NULL, 
       CLIENT_INFO VARCHAR(55) NULL, 
       HASSAVEBOX BIT default 0 NOT NULL, FK_VA1 INTEGER NULL, 
       FK_VA2 VARCHAR(55) NULL, HASCREDITCARD BIT default 0 NOT NULL,
       PRIMARY KEY (CLIENTID));

CREATE TABLE CLIENT_ACCT (C_ID VARCHAR(55) NOT NULL, 
       A_ID VARCHAR(55) NOT NULL, PRIMARY KEY (C_ID, A_ID));

CREATE TABLE ACCOUNT (ACCTNUM VARCHAR(55) NOT NULL, 
       DCOL VARCHAR(31) NULL, BALANCE FLOAT(16) NULL, 
       NAME VARCHAR(55) NULL, CREATED VARCHAR(55) NULL, 
       DESCRIPTION VARCHAR(55) NULL, STATUS INTEGER NULL, 
       BANK_NAME VARCHAR(55) NULL, 
       ISOVERDRAFTALLOWED BIT default 0 NOT NULL, 
       BANKNAME VARCHAR(55) NULL, SAVINGSRATE FLOAT(16) NULL, 
       TRADEFEES FLOAT(16) NULL, MAXLOANALLOWED FLOAT(16) NULL, 
       CREDITCARDNUMBER VARCHAR(55) NULL, 
       ISSUINGBANK VARCHAR(55) NULL, EXPIRESON VARCHAR(55) NULL, 
       PRIMARY KEY (ACCTNUM));

CREATE TABLE PHONEAGENT (DTYPE VARCHAR(31) NULL, 
       AGENTNAME VARCHAR(55) NULL, LOCATIONID VARCHAR(55) NULL, 
       LOCALPHONE VARCHAR(55) NULL, TOLLPHONE VARCHAR(55) NULL, 
       PK1 VARCHAR(55) NOT NULL, PK2 VARCHAR(55) NOT NULL, 
       PRIMARY KEY (PK1, PK2));

CREATE TABLE PHONEAGENTEXT (PA_PK1 VARCHAR(55) NOT NULL, 
       PA_PK2 VARCHAR(55) NOT NULL, EXT1 VARCHAR(55) NULL, 
       EXT2 VARCHAR(55) NULL, PRIMARY KEY (PA_PK1, PA_PK2));

CREATE TABLE C_INFO (INFO_ID VARCHAR(55) NOT NULL, 
       PROP2 VARCHAR(55) NULL, PRIMARY KEY (INFO_ID));

ALTER TABLE CLIENT_PHONEAGENT ADD CONSTRAINT CLIENT_PHONEAGENT_C_ID 
      FOREIGN KEY (C_ID) REFERENCES DUMMYCLIENT (CLIENTID);

ALTER TABLE CLIENT_PHONEAGENT ADD CONSTRAINT CLIENTPHONEAGENTPA_ID 
      FOREIGN KEY (PA_ID1, PA_ID2) REFERENCES PHONEAGENT (PK1, PK2);

ALTER TABLE DUMMYCLIENT ADD CONSTRAINT DUMMYCLIENTCLIENT_INFO 
      FOREIGN KEY (CLIENT_INFO) REFERENCES BASE_INFO (ID);

ALTER TABLE DUMMYCLIENT ADD CONSTRAINT FK_DUMMYCLIENT_FK_VA
      FOREIGN KEY (FK_VA1, FK_VA2) REFERENCES VIPCLIENTAGENT (PK1I, PK2S);

ALTER TABLE CLIENT_ACCT ADD CONSTRAINT FK_CLIENT_ACCT_C_ID 
      FOREIGN KEY (C_ID) REFERENCES DUMMYCLIENT (CLIENTID);

ALTER TABLE CLIENT_ACCT ADD CONSTRAINT FK_CLIENT_ACCT_A_ID 
      FOREIGN KEY (A_ID) REFERENCES ACCOUNT (ACCTNUM);

ALTER TABLE PHONEAGENTEXT ADD CONSTRAINT PHONEAGENTEXT_PA_PK
      FOREIGN KEY (PA_PK1, PA_PK2) REFERENCES PHONEAGENT (PK1, PK2);

ALTER TABLE C_INFO ADD CONSTRAINT FK_C_INFO_INFO_ID FOREIGN 
      KEY (INFO_ID) REFERENCES BASE_INFO (ID);

